#define g65816_setn() gx816->regs.p |=  PF_N
#define g65816_clrn() gx816->regs.p &= ~PF_N
#define g65816_setv() gx816->regs.p |=  PF_V
#define g65816_clrv() gx816->regs.p &= ~PF_V
#define g65816_setm() gx816->regs.p |=  PF_M
#define g65816_clrm() gx816->regs.p &= ~PF_M
#define g65816_setx() gx816->regs.p |=  PF_X
#define g65816_clrx() gx816->regs.p &= ~PF_X
#define g65816_setd() gx816->regs.p |=  PF_D
#define g65816_clrd() gx816->regs.p &= ~PF_D
#define g65816_seti() gx816->regs.p |=  PF_I
#define g65816_clri() gx816->regs.p &= ~PF_I
#define g65816_setz() gx816->regs.p |=  PF_Z
#define g65816_clrz() gx816->regs.p &= ~PF_Z
#define g65816_setc() gx816->regs.p |=  PF_C
#define g65816_clrc() gx816->regs.p &= ~PF_C
#define g65816_testn(x) if(x)g65816_setn(); else g65816_clrn()
#define g65816_testv(x) if(x)g65816_setv(); else g65816_clrv()
#define g65816_testd(x) if(x)g65816_setd(); else g65816_clrd()
#define g65816_testi(x) if(x)g65816_seti(); else g65816_clri()
#define g65816_testz(x) if(x)g65816_setz(); else g65816_clrz()
#define g65816_testc(x) if(x)g65816_setc(); else g65816_clrc()

//increment program counter, wrap around pbr
#define g65816_incpc(__n) gx816->regs.pc = (gx816->regs.pc & 0xff0000) | (word)(gx816->regs.pc + __n)

/*
  vpa = 1, vda = 1 -> add_cpu_pcycles (opcode fetch)
  vpa = 1, vda = 0 -> add_cpu_pcycles (operand fetch)
  vpa = 0, vda = 1 -> add_cpu_dcycles (memory fetch)
  vpa = 0, vda = 0 -> add_cpu_icycles (internal operation)
*/

//opcode functions
#include "g65816_ops_adc.cpp"
#include "g65816_ops_and.cpp"
#include "g65816_ops_cmp.cpp"
#include "g65816_ops_eor.cpp"
#include "g65816_ops_lda.cpp"
#include "g65816_ops_ora.cpp"
#include "g65816_ops_sbc.cpp"
#include "g65816_ops_sta.cpp"
#include "g65816_ops_incdec.cpp"
#include "g65816_ops_shift.cpp"
#include "g65816_ops_stack.cpp"
#include "g65816_ops_pc.cpp"
#include "g65816_ops_misc.cpp"

vfunc g65816_optbl_e[256] = { //                                                                                 g65816_optbl_e,                                                                                                  g65816_optbl_e,                                                                                                  g65816_optbl_e,
      // ----------------------x0, ----------------------x1, ----------------------x2, ----------------------x3, -------- ----------------------x4, ----------------------x5, ----------------------x6, ----------------------x7, -------- ----------------------x8, ----------------------x9, ----------------------xa, ----------------------xb, -------- ----------------------xc, ----------------------xd, ----------------------xe, ----------------------xf,
/* 0x */            g65816_op_brk,      g65816_op_ora_idpxb,            g65816_op_cop,        g65816_op_ora_srb, /* 0x */        g65816_op_tsb_dpb,        g65816_op_ora_dpb,        g65816_op_asl_dpb,      g65816_op_ora_ildpb, /* 0x */            g65816_op_php,     g65816_op_ora_constb,           g65816_op_aslb,            g65816_op_phd, /* 0x */      g65816_op_tsb_addrb,      g65816_op_ora_addrb,      g65816_op_asl_addrb,      g65816_op_ora_longb,
/* 1x */            g65816_op_bpl,      g65816_op_ora_idpyb,       g65816_op_ora_idpb,      g65816_op_ora_isryb, /* 1x */        g65816_op_trb_dpb,       g65816_op_ora_dpxb,       g65816_op_asl_dpxb,     g65816_op_ora_ildpyb, /* 1x */            g65816_op_clc,     g65816_op_ora_addryb,           g65816_op_incb,           g65816_op_tcse, /* 1x */      g65816_op_trb_addrb,     g65816_op_ora_addrxb,     g65816_op_asl_addrxb,     g65816_op_ora_longxb,
/* 2x */       g65816_op_jsr_addr,      g65816_op_and_idpxb,       g65816_op_jsr_long,        g65816_op_and_srb, /* 2x */        g65816_op_bit_dpb,        g65816_op_and_dpb,        g65816_op_rol_dpb,      g65816_op_and_ildpb, /* 2x */            g65816_op_plp,     g65816_op_and_constb,           g65816_op_rolb,            g65816_op_pld, /* 2x */      g65816_op_bit_addrb,      g65816_op_and_addrb,      g65816_op_rol_addrb,      g65816_op_and_longb,
/* 3x */            g65816_op_bmi,      g65816_op_and_idpyb,       g65816_op_and_idpb,      g65816_op_and_isryb, /* 3x */       g65816_op_bit_dpxb,       g65816_op_and_dpxb,       g65816_op_rol_dpxb,     g65816_op_and_ildpyb, /* 3x */            g65816_op_sec,     g65816_op_and_addryb,           g65816_op_decb,           g65816_op_tsce, /* 3x */     g65816_op_bit_addrxb,     g65816_op_and_addrxb,     g65816_op_rol_addrxb,     g65816_op_and_longxb,

/* 4x */           g65816_op_rtie,      g65816_op_eor_idpxb,            g65816_op_wdm,        g65816_op_eor_srb, /* 4x */            g65816_op_mvp,        g65816_op_eor_dpb,        g65816_op_lsr_dpb,      g65816_op_eor_ildpb, /* 4x */           g65816_op_phab,     g65816_op_eor_constb,           g65816_op_lsrb,            g65816_op_phk, /* 4x */       g65816_op_jmp_addr,      g65816_op_eor_addrb,      g65816_op_lsr_addrb,      g65816_op_eor_longb,
/* 5x */            g65816_op_bvc,      g65816_op_eor_idpyb,       g65816_op_eor_idpb,      g65816_op_eor_isryb, /* 5x */            g65816_op_mvn,       g65816_op_eor_dpxb,       g65816_op_lsr_dpxb,     g65816_op_eor_ildpyb, /* 5x */            g65816_op_cli,     g65816_op_eor_addryb,           g65816_op_phyb,            g65816_op_tcd, /* 5x */       g65816_op_jmp_long,     g65816_op_eor_addrxb,     g65816_op_lsr_addrxb,     g65816_op_eor_longxb,
/* 6x */            g65816_op_rts,      g65816_op_adc_idpxb,            g65816_op_per,        g65816_op_adc_srb, /* 6x */        g65816_op_stz_dpb,        g65816_op_adc_dpb,        g65816_op_ror_dpb,      g65816_op_adc_ildpb, /* 6x */           g65816_op_plab,     g65816_op_adc_constb,           g65816_op_rorb,            g65816_op_rtl, /* 6x */      g65816_op_jmp_iaddr,      g65816_op_adc_addrb,      g65816_op_ror_addrb,      g65816_op_adc_longb,
/* 7x */            g65816_op_bvs,      g65816_op_adc_idpyb,       g65816_op_adc_idpb,      g65816_op_adc_isryb, /* 7x */       g65816_op_stz_dpxb,       g65816_op_adc_dpxb,       g65816_op_ror_dpxb,     g65816_op_adc_ildpyb, /* 7x */            g65816_op_sei,     g65816_op_adc_addryb,           g65816_op_plyb,               g65816_tdc, /* 7x */     g65816_op_jmp_iaddrx,     g65816_op_adc_addrxb,     g65816_op_ror_addrxb,     g65816_op_adc_longxb,

/* 8x */            g65816_op_bra,      g65816_op_sta_idpxb,            g65816_op_brl,        g65816_op_sta_srb, /* 8x */        g65816_op_sty_dpb,        g65816_op_sta_dpb,        g65816_op_stx_dpb,      g65816_op_sta_ildpb, /* 8x */           g65816_op_deyb,     g65816_op_bit_constb,           g65816_op_txab,            g65816_op_phb, /* 8x */      g65816_op_sty_addrb,      g65816_op_sta_addrb,      g65816_op_stx_addrb,      g65816_op_sta_longb,
/* 9x */            g65816_op_bcc,      g65816_op_sta_idpyb,       g65816_op_sta_idpb,      g65816_op_sta_isryb, /* 9x */       g65816_op_sty_dpxb,       g65816_op_sta_dpxb,       g65816_op_stx_dpyb,     g65816_op_sta_ildpyb, /* 9x */           g65816_op_tyab,     g65816_op_sta_addryb,           g65816_op_txsb,           g65816_op_txyb, /* 9x */      g65816_op_stz_addrb,     g65816_op_sta_addrxb,     g65816_op_stz_addrxb,     g65816_op_sta_longxb,
/* ax */     g65816_op_ldy_constb,      g65816_op_lda_idpxb,     g65816_op_ldx_constb,        g65816_op_lda_srb, /* ax */        g65816_op_ldy_dpb,        g65816_op_lda_dpb,        g65816_op_ldx_dpb,      g65816_op_lda_ildpb, /* ax */           g65816_op_tayb,     g65816_op_lda_constb,           g65816_op_taxb,            g65816_op_plb, /* ax */      g65816_op_ldy_addrb,      g65816_op_lda_addrb,      g65816_op_ldx_addrb,      g65816_op_lda_longb,
/* bx */            g65816_op_bcs,      g65816_op_lda_idpyb,       g65816_op_lda_idpb,      g65816_op_lda_isryb, /* bx */       g65816_op_ldy_dpxb,       g65816_op_lda_dpxb,       g65816_op_ldx_dpyb,     g65816_op_lda_ildpyb, /* bx */            g65816_op_clv,     g65816_op_lda_addryb,           g65816_op_tsxb,           g65816_op_tyxb, /* bx */     g65816_op_ldy_addrxb,     g65816_op_lda_addrxb,     g65816_op_ldx_addryb,     g65816_op_lda_longxb,

/* cx */     g65816_op_cpy_constb,      g65816_op_cmp_idpxb,            g65816_op_rep,        g65816_op_cmp_srb, /* cx */        g65816_op_cpy_dpb,        g65816_op_cmp_dpb,        g65816_op_dec_dpb,      g65816_op_cmp_ildpb, /* cx */           g65816_op_inyb,     g65816_op_cmp_constb,           g65816_op_dexb,            g65816_op_wai, /* cx */      g65816_op_cpy_addrb,      g65816_op_cmp_addrb,      g65816_op_dec_addrb,      g65816_op_cmp_longb,
/* dx */            g65816_op_bne,      g65816_op_cmp_idpyb,       g65816_op_cmp_idpb,      g65816_op_cmp_isryb, /* dx */            g65816_op_pei,       g65816_op_cmp_dpxb,       g65816_op_dec_dpxb,     g65816_op_cmp_ildpyb, /* dx */            g65816_op_cld,     g65816_op_cmp_addryb,           g65816_op_phxb,            g65816_op_stp, /* dx */     g65816_op_jmp_iladdr,     g65816_op_cmp_addrxb,     g65816_op_dec_addrxb,     g65816_op_cmp_longxb,
/* ex */     g65816_op_cpx_constb,      g65816_op_sbc_idpxb,            g65816_op_sep,        g65816_op_sbc_srb, /* ex */        g65816_op_cpx_dpb,        g65816_op_sbc_dpb,        g65816_op_inc_dpb,      g65816_op_sbc_ildpb, /* ex */           g65816_op_inxb,     g65816_op_sbc_constb,            g65816_op_nop,            g65816_op_xba, /* ex */      g65816_op_cpx_addrb,      g65816_op_sbc_addrb,      g65816_op_inc_addrb,      g65816_op_sbc_longb,
/* fx */            g65816_op_beq,      g65816_op_sbc_idpyb,       g65816_op_sbc_idpb,      g65816_op_sbc_isryb, /* fx */            g65816_op_pea,       g65816_op_sbc_dpxb,       g65816_op_inc_dpxb,     g65816_op_sbc_ildpyb, /* fx */            g65816_op_sed,     g65816_op_sbc_addryb,           g65816_op_plxb,            g65816_op_xce, /* fx */     g65816_op_jsr_iaddrx,     g65816_op_sbc_addrxb,     g65816_op_inc_addrxb,     g65816_op_sbc_longxb
};

vfunc g65816_optbl_MX[256] = { //                                                                                g65816_optbl_MX,                                                                                                 g65816_optbl_MX,                                                                                                 g65816_optbl_MX,
      // ----------------------x0, ----------------------x1, ----------------------x2, ----------------------x3, -------- ----------------------x4, ----------------------x5, ----------------------x6, ----------------------x7, -------- ----------------------x8, ----------------------x9, ----------------------xa, ----------------------xb, -------- ----------------------xc, ----------------------xd, ----------------------xe, ----------------------xf,
/* 0x */            g65816_op_brk,      g65816_op_ora_idpxb,            g65816_op_cop,        g65816_op_ora_srb, /* 0x */        g65816_op_tsb_dpb,        g65816_op_ora_dpb,        g65816_op_asl_dpb,      g65816_op_ora_ildpb, /* 0x */            g65816_op_php,     g65816_op_ora_constb,           g65816_op_aslb,            g65816_op_phd, /* 0x */      g65816_op_tsb_addrb,      g65816_op_ora_addrb,      g65816_op_asl_addrb,      g65816_op_ora_longb,
/* 1x */            g65816_op_bpl,      g65816_op_ora_idpyb,       g65816_op_ora_idpb,      g65816_op_ora_isryb, /* 1x */        g65816_op_trb_dpb,       g65816_op_ora_dpxb,       g65816_op_asl_dpxb,     g65816_op_ora_ildpyb, /* 1x */            g65816_op_clc,     g65816_op_ora_addryb,           g65816_op_incb,           g65816_op_tcsn, /* 1x */      g65816_op_trb_addrb,     g65816_op_ora_addrxb,     g65816_op_asl_addrxb,     g65816_op_ora_longxb,
/* 2x */       g65816_op_jsr_addr,      g65816_op_and_idpxb,       g65816_op_jsr_long,        g65816_op_and_srb, /* 2x */        g65816_op_bit_dpb,        g65816_op_and_dpb,        g65816_op_rol_dpb,      g65816_op_and_ildpb, /* 2x */            g65816_op_plp,     g65816_op_and_constb,           g65816_op_rolb,            g65816_op_pld, /* 2x */      g65816_op_bit_addrb,      g65816_op_and_addrb,      g65816_op_rol_addrb,      g65816_op_and_longb,
/* 3x */            g65816_op_bmi,      g65816_op_and_idpyb,       g65816_op_and_idpb,      g65816_op_and_isryb, /* 3x */       g65816_op_bit_dpxb,       g65816_op_and_dpxb,       g65816_op_rol_dpxb,     g65816_op_and_ildpyb, /* 3x */            g65816_op_sec,     g65816_op_and_addryb,           g65816_op_decb,           g65816_op_tscn, /* 3x */     g65816_op_bit_addrxb,     g65816_op_and_addrxb,     g65816_op_rol_addrxb,     g65816_op_and_longxb,

/* 4x */           g65816_op_rtin,      g65816_op_eor_idpxb,            g65816_op_wdm,        g65816_op_eor_srb, /* 4x */            g65816_op_mvp,        g65816_op_eor_dpb,        g65816_op_lsr_dpb,      g65816_op_eor_ildpb, /* 4x */           g65816_op_phab,     g65816_op_eor_constb,           g65816_op_lsrb,            g65816_op_phk, /* 4x */       g65816_op_jmp_addr,      g65816_op_eor_addrb,      g65816_op_lsr_addrb,      g65816_op_eor_longb,
/* 5x */            g65816_op_bvc,      g65816_op_eor_idpyb,       g65816_op_eor_idpb,      g65816_op_eor_isryb, /* 5x */            g65816_op_mvn,       g65816_op_eor_dpxb,       g65816_op_lsr_dpxb,     g65816_op_eor_ildpyb, /* 5x */            g65816_op_cli,     g65816_op_eor_addryb,           g65816_op_phyb,            g65816_op_tcd, /* 5x */       g65816_op_jmp_long,     g65816_op_eor_addrxb,     g65816_op_lsr_addrxb,     g65816_op_eor_longxb,
/* 6x */            g65816_op_rts,      g65816_op_adc_idpxb,            g65816_op_per,        g65816_op_adc_srb, /* 6x */        g65816_op_stz_dpb,        g65816_op_adc_dpb,        g65816_op_ror_dpb,      g65816_op_adc_ildpb, /* 6x */           g65816_op_plab,     g65816_op_adc_constb,           g65816_op_rorb,            g65816_op_rtl, /* 6x */      g65816_op_jmp_iaddr,      g65816_op_adc_addrb,      g65816_op_ror_addrb,      g65816_op_adc_longb,
/* 7x */            g65816_op_bvs,      g65816_op_adc_idpyb,       g65816_op_adc_idpb,      g65816_op_adc_isryb, /* 7x */       g65816_op_stz_dpxb,       g65816_op_adc_dpxb,       g65816_op_ror_dpxb,     g65816_op_adc_ildpyb, /* 7x */            g65816_op_sei,     g65816_op_adc_addryb,           g65816_op_plyb,               g65816_tdc, /* 7x */     g65816_op_jmp_iaddrx,     g65816_op_adc_addrxb,     g65816_op_ror_addrxb,     g65816_op_adc_longxb,

/* 8x */            g65816_op_bra,      g65816_op_sta_idpxb,            g65816_op_brl,        g65816_op_sta_srb, /* 8x */        g65816_op_sty_dpb,        g65816_op_sta_dpb,        g65816_op_stx_dpb,      g65816_op_sta_ildpb, /* 8x */           g65816_op_deyb,     g65816_op_bit_constb,           g65816_op_txab,            g65816_op_phb, /* 8x */      g65816_op_sty_addrb,      g65816_op_sta_addrb,      g65816_op_stx_addrb,      g65816_op_sta_longb,
/* 9x */            g65816_op_bcc,      g65816_op_sta_idpyb,       g65816_op_sta_idpb,      g65816_op_sta_isryb, /* 9x */       g65816_op_sty_dpxb,       g65816_op_sta_dpxb,       g65816_op_stx_dpyb,     g65816_op_sta_ildpyb, /* 9x */           g65816_op_tyab,     g65816_op_sta_addryb,           g65816_op_txsb,           g65816_op_txyb, /* 9x */      g65816_op_stz_addrb,     g65816_op_sta_addrxb,     g65816_op_stz_addrxb,     g65816_op_sta_longxb,
/* ax */     g65816_op_ldy_constb,      g65816_op_lda_idpxb,     g65816_op_ldx_constb,        g65816_op_lda_srb, /* ax */        g65816_op_ldy_dpb,        g65816_op_lda_dpb,        g65816_op_ldx_dpb,      g65816_op_lda_ildpb, /* ax */           g65816_op_tayb,     g65816_op_lda_constb,           g65816_op_taxb,            g65816_op_plb, /* ax */      g65816_op_ldy_addrb,      g65816_op_lda_addrb,      g65816_op_ldx_addrb,      g65816_op_lda_longb,
/* bx */            g65816_op_bcs,      g65816_op_lda_idpyb,       g65816_op_lda_idpb,      g65816_op_lda_isryb, /* bx */       g65816_op_ldy_dpxb,       g65816_op_lda_dpxb,       g65816_op_ldx_dpyb,     g65816_op_lda_ildpyb, /* bx */            g65816_op_clv,     g65816_op_lda_addryb,           g65816_op_tsxb,           g65816_op_tyxb, /* bx */     g65816_op_ldy_addrxb,     g65816_op_lda_addrxb,     g65816_op_ldx_addryb,     g65816_op_lda_longxb,

/* cx */     g65816_op_cpy_constb,      g65816_op_cmp_idpxb,            g65816_op_rep,        g65816_op_cmp_srb, /* cx */        g65816_op_cpy_dpb,        g65816_op_cmp_dpb,        g65816_op_dec_dpb,      g65816_op_cmp_ildpb, /* cx */           g65816_op_inyb,     g65816_op_cmp_constb,           g65816_op_dexb,            g65816_op_wai, /* cx */      g65816_op_cpy_addrb,      g65816_op_cmp_addrb,      g65816_op_dec_addrb,      g65816_op_cmp_longb,
/* dx */            g65816_op_bne,      g65816_op_cmp_idpyb,       g65816_op_cmp_idpb,      g65816_op_cmp_isryb, /* dx */            g65816_op_pei,       g65816_op_cmp_dpxb,       g65816_op_dec_dpxb,     g65816_op_cmp_ildpyb, /* dx */            g65816_op_cld,     g65816_op_cmp_addryb,           g65816_op_phxb,            g65816_op_stp, /* dx */     g65816_op_jmp_iladdr,     g65816_op_cmp_addrxb,     g65816_op_dec_addrxb,     g65816_op_cmp_longxb,
/* ex */     g65816_op_cpx_constb,      g65816_op_sbc_idpxb,            g65816_op_sep,        g65816_op_sbc_srb, /* ex */        g65816_op_cpx_dpb,        g65816_op_sbc_dpb,        g65816_op_inc_dpb,      g65816_op_sbc_ildpb, /* ex */           g65816_op_inxb,     g65816_op_sbc_constb,            g65816_op_nop,            g65816_op_xba, /* ex */      g65816_op_cpx_addrb,      g65816_op_sbc_addrb,      g65816_op_inc_addrb,      g65816_op_sbc_longb,
/* fx */            g65816_op_beq,      g65816_op_sbc_idpyb,       g65816_op_sbc_idpb,      g65816_op_sbc_isryb, /* fx */            g65816_op_pea,       g65816_op_sbc_dpxb,       g65816_op_inc_dpxb,     g65816_op_sbc_ildpyb, /* fx */            g65816_op_sed,     g65816_op_sbc_addryb,           g65816_op_plxb,            g65816_op_xce, /* fx */     g65816_op_jsr_iaddrx,     g65816_op_sbc_addrxb,     g65816_op_inc_addrxb,     g65816_op_sbc_longxb
};

vfunc g65816_optbl_Mx[256] = { //                                                                                g65816_optbl_Mx,                                                                                                 g65816_optbl_Mx,                                                                                                 g65816_optbl_Mx,
      // ----------------------x0, ----------------------x1, ----------------------x2, ----------------------x3, -------- ----------------------x4, ----------------------x5, ----------------------x6, ----------------------x7, -------- ----------------------x8, ----------------------x9, ----------------------xa, ----------------------xb, -------- ----------------------xc, ----------------------xd, ----------------------xe, ----------------------xf,
/* 0x */            g65816_op_brk,      g65816_op_ora_idpxb,            g65816_op_cop,        g65816_op_ora_srb, /* 0x */        g65816_op_tsb_dpb,        g65816_op_ora_dpb,        g65816_op_asl_dpb,      g65816_op_ora_ildpb, /* 0x */            g65816_op_php,     g65816_op_ora_constb,           g65816_op_aslb,            g65816_op_phd, /* 0x */      g65816_op_tsb_addrb,      g65816_op_ora_addrb,      g65816_op_asl_addrb,      g65816_op_ora_longb,
/* 1x */            g65816_op_bpl,      g65816_op_ora_idpyb,       g65816_op_ora_idpb,      g65816_op_ora_isryb, /* 1x */        g65816_op_trb_dpb,       g65816_op_ora_dpxb,       g65816_op_asl_dpxb,     g65816_op_ora_ildpyb, /* 1x */            g65816_op_clc,     g65816_op_ora_addryb,           g65816_op_incb,           g65816_op_tcsn, /* 1x */      g65816_op_trb_addrb,     g65816_op_ora_addrxb,     g65816_op_asl_addrxb,     g65816_op_ora_longxb,
/* 2x */       g65816_op_jsr_addr,      g65816_op_and_idpxb,       g65816_op_jsr_long,        g65816_op_and_srb, /* 2x */        g65816_op_bit_dpb,        g65816_op_and_dpb,        g65816_op_rol_dpb,      g65816_op_and_ildpb, /* 2x */            g65816_op_plp,     g65816_op_and_constb,           g65816_op_rolb,            g65816_op_pld, /* 2x */      g65816_op_bit_addrb,      g65816_op_and_addrb,      g65816_op_rol_addrb,      g65816_op_and_longb,
/* 3x */            g65816_op_bmi,      g65816_op_and_idpyb,       g65816_op_and_idpb,      g65816_op_and_isryb, /* 3x */       g65816_op_bit_dpxb,       g65816_op_and_dpxb,       g65816_op_rol_dpxb,     g65816_op_and_ildpyb, /* 3x */            g65816_op_sec,     g65816_op_and_addryb,           g65816_op_decb,           g65816_op_tscn, /* 3x */     g65816_op_bit_addrxb,     g65816_op_and_addrxb,     g65816_op_rol_addrxb,     g65816_op_and_longxb,

/* 4x */           g65816_op_rtin,      g65816_op_eor_idpxb,            g65816_op_wdm,        g65816_op_eor_srb, /* 4x */            g65816_op_mvp,        g65816_op_eor_dpb,        g65816_op_lsr_dpb,      g65816_op_eor_ildpb, /* 4x */           g65816_op_phab,     g65816_op_eor_constb,           g65816_op_lsrb,            g65816_op_phk, /* 4x */       g65816_op_jmp_addr,      g65816_op_eor_addrb,      g65816_op_lsr_addrb,      g65816_op_eor_longb,
/* 5x */            g65816_op_bvc,      g65816_op_eor_idpyb,       g65816_op_eor_idpb,      g65816_op_eor_isryb, /* 5x */            g65816_op_mvn,       g65816_op_eor_dpxb,       g65816_op_lsr_dpxb,     g65816_op_eor_ildpyb, /* 5x */            g65816_op_cli,     g65816_op_eor_addryb,           g65816_op_phyw,            g65816_op_tcd, /* 5x */       g65816_op_jmp_long,     g65816_op_eor_addrxb,     g65816_op_lsr_addrxb,     g65816_op_eor_longxb,
/* 6x */            g65816_op_rts,      g65816_op_adc_idpxb,            g65816_op_per,        g65816_op_adc_srb, /* 6x */        g65816_op_stz_dpb,        g65816_op_adc_dpb,        g65816_op_ror_dpb,      g65816_op_adc_ildpb, /* 6x */           g65816_op_plab,     g65816_op_adc_constb,           g65816_op_rorb,            g65816_op_rtl, /* 6x */      g65816_op_jmp_iaddr,      g65816_op_adc_addrb,      g65816_op_ror_addrb,      g65816_op_adc_longb,
/* 7x */            g65816_op_bvs,      g65816_op_adc_idpyb,       g65816_op_adc_idpb,      g65816_op_adc_isryb, /* 7x */       g65816_op_stz_dpxb,       g65816_op_adc_dpxb,       g65816_op_ror_dpxb,     g65816_op_adc_ildpyb, /* 7x */            g65816_op_sei,     g65816_op_adc_addryb,           g65816_op_plyw,               g65816_tdc, /* 7x */     g65816_op_jmp_iaddrx,     g65816_op_adc_addrxb,     g65816_op_ror_addrxb,     g65816_op_adc_longxb,

/* 8x */            g65816_op_bra,      g65816_op_sta_idpxb,            g65816_op_brl,        g65816_op_sta_srb, /* 8x */        g65816_op_sty_dpw,        g65816_op_sta_dpb,        g65816_op_stx_dpw,      g65816_op_sta_ildpb, /* 8x */           g65816_op_deyw,     g65816_op_bit_constb,           g65816_op_txab,            g65816_op_phb, /* 8x */      g65816_op_sty_addrw,      g65816_op_sta_addrb,      g65816_op_stx_addrw,      g65816_op_sta_longb,
/* 9x */            g65816_op_bcc,      g65816_op_sta_idpyb,       g65816_op_sta_idpb,      g65816_op_sta_isryb, /* 9x */       g65816_op_sty_dpxw,       g65816_op_sta_dpxb,       g65816_op_stx_dpyw,     g65816_op_sta_ildpyb, /* 9x */           g65816_op_tyab,     g65816_op_sta_addryb,           g65816_op_txsw,           g65816_op_txyw, /* 9x */      g65816_op_stz_addrb,     g65816_op_sta_addrxb,     g65816_op_stz_addrxb,     g65816_op_sta_longxb,
/* ax */     g65816_op_ldy_constw,      g65816_op_lda_idpxb,     g65816_op_ldx_constw,        g65816_op_lda_srb, /* ax */        g65816_op_ldy_dpw,        g65816_op_lda_dpb,        g65816_op_ldx_dpw,      g65816_op_lda_ildpb, /* ax */           g65816_op_tayw,     g65816_op_lda_constb,           g65816_op_taxw,            g65816_op_plb, /* ax */      g65816_op_ldy_addrw,      g65816_op_lda_addrb,      g65816_op_ldx_addrw,      g65816_op_lda_longb,
/* bx */            g65816_op_bcs,      g65816_op_lda_idpyb,       g65816_op_lda_idpb,      g65816_op_lda_isryb, /* bx */       g65816_op_ldy_dpxw,       g65816_op_lda_dpxb,       g65816_op_ldx_dpyw,     g65816_op_lda_ildpyb, /* bx */            g65816_op_clv,     g65816_op_lda_addryb,           g65816_op_tsxw,           g65816_op_tyxw, /* bx */     g65816_op_ldy_addrxw,     g65816_op_lda_addrxb,     g65816_op_ldx_addryw,     g65816_op_lda_longxb,

/* cx */     g65816_op_cpy_constw,      g65816_op_cmp_idpxb,            g65816_op_rep,        g65816_op_cmp_srb, /* cx */        g65816_op_cpy_dpw,        g65816_op_cmp_dpb,        g65816_op_dec_dpb,      g65816_op_cmp_ildpb, /* cx */           g65816_op_inyw,     g65816_op_cmp_constb,           g65816_op_dexw,            g65816_op_wai, /* cx */      g65816_op_cpy_addrw,      g65816_op_cmp_addrb,      g65816_op_dec_addrb,      g65816_op_cmp_longb,
/* dx */            g65816_op_bne,      g65816_op_cmp_idpyb,       g65816_op_cmp_idpb,      g65816_op_cmp_isryb, /* dx */            g65816_op_pei,       g65816_op_cmp_dpxb,       g65816_op_dec_dpxb,     g65816_op_cmp_ildpyb, /* dx */            g65816_op_cld,     g65816_op_cmp_addryb,           g65816_op_phxw,            g65816_op_stp, /* dx */     g65816_op_jmp_iladdr,     g65816_op_cmp_addrxb,     g65816_op_dec_addrxb,     g65816_op_cmp_longxb,
/* ex */     g65816_op_cpx_constw,      g65816_op_sbc_idpxb,            g65816_op_sep,        g65816_op_sbc_srb, /* ex */        g65816_op_cpx_dpw,        g65816_op_sbc_dpb,        g65816_op_inc_dpb,      g65816_op_sbc_ildpb, /* ex */           g65816_op_inxw,     g65816_op_sbc_constb,            g65816_op_nop,            g65816_op_xba, /* ex */      g65816_op_cpx_addrw,      g65816_op_sbc_addrb,      g65816_op_inc_addrb,      g65816_op_sbc_longb,
/* fx */            g65816_op_beq,      g65816_op_sbc_idpyb,       g65816_op_sbc_idpb,      g65816_op_sbc_isryb, /* fx */            g65816_op_pea,       g65816_op_sbc_dpxb,       g65816_op_inc_dpxb,     g65816_op_sbc_ildpyb, /* fx */            g65816_op_sed,     g65816_op_sbc_addryb,           g65816_op_plxw,            g65816_op_xce, /* fx */     g65816_op_jsr_iaddrx,     g65816_op_sbc_addrxb,     g65816_op_inc_addrxb,     g65816_op_sbc_longxb
};

vfunc g65816_optbl_mX[256] = { //                                                                                g65816_optbl_mX,                                                                                                 g65816_optbl_mX,                                                                                                 g65816_optbl_mX,
      // ----------------------x0, ----------------------x1, ----------------------x2, ----------------------x3, -------- ----------------------x4, ----------------------x5, ----------------------x6, ----------------------x7, -------- ----------------------x8, ----------------------x9, ----------------------xa, ----------------------xb, -------- ----------------------xc, ----------------------xd, ----------------------xe, ----------------------xf,
/* 0x */            g65816_op_brk,      g65816_op_ora_idpxw,            g65816_op_cop,        g65816_op_ora_srw, /* 0x */        g65816_op_tsb_dpw,        g65816_op_ora_dpw,        g65816_op_asl_dpw,      g65816_op_ora_ildpw, /* 0x */            g65816_op_php,     g65816_op_ora_constw,           g65816_op_aslw,            g65816_op_phd, /* 0x */      g65816_op_tsb_addrw,      g65816_op_ora_addrw,      g65816_op_asl_addrw,      g65816_op_ora_longw,
/* 1x */            g65816_op_bpl,      g65816_op_ora_idpyw,       g65816_op_ora_idpw,      g65816_op_ora_isryw, /* 1x */        g65816_op_trb_dpw,       g65816_op_ora_dpxw,       g65816_op_asl_dpxw,     g65816_op_ora_ildpyw, /* 1x */            g65816_op_clc,     g65816_op_ora_addryw,           g65816_op_incw,           g65816_op_tcsn, /* 1x */      g65816_op_trb_addrw,     g65816_op_ora_addrxw,     g65816_op_asl_addrxw,     g65816_op_ora_longxw,
/* 2x */       g65816_op_jsr_addr,      g65816_op_and_idpxw,       g65816_op_jsr_long,        g65816_op_and_srw, /* 2x */        g65816_op_bit_dpw,        g65816_op_and_dpw,        g65816_op_rol_dpw,      g65816_op_and_ildpw, /* 2x */            g65816_op_plp,     g65816_op_and_constw,           g65816_op_rolw,            g65816_op_pld, /* 2x */      g65816_op_bit_addrw,      g65816_op_and_addrw,      g65816_op_rol_addrw,      g65816_op_and_longw,
/* 3x */            g65816_op_bmi,      g65816_op_and_idpyw,       g65816_op_and_idpw,      g65816_op_and_isryw, /* 3x */       g65816_op_bit_dpxw,       g65816_op_and_dpxw,       g65816_op_rol_dpxw,     g65816_op_and_ildpyw, /* 3x */            g65816_op_sec,     g65816_op_and_addryw,           g65816_op_decw,           g65816_op_tscn, /* 3x */     g65816_op_bit_addrxw,     g65816_op_and_addrxw,     g65816_op_rol_addrxw,     g65816_op_and_longxw,

/* 4x */           g65816_op_rtin,      g65816_op_eor_idpxw,            g65816_op_wdm,        g65816_op_eor_srw, /* 4x */            g65816_op_mvp,        g65816_op_eor_dpw,        g65816_op_lsr_dpw,      g65816_op_eor_ildpw, /* 4x */           g65816_op_phaw,     g65816_op_eor_constw,           g65816_op_lsrw,            g65816_op_phk, /* 4x */       g65816_op_jmp_addr,      g65816_op_eor_addrw,      g65816_op_lsr_addrw,      g65816_op_eor_longw,
/* 5x */            g65816_op_bvc,      g65816_op_eor_idpyw,       g65816_op_eor_idpw,      g65816_op_eor_isryw, /* 5x */            g65816_op_mvn,       g65816_op_eor_dpxw,       g65816_op_lsr_dpxw,     g65816_op_eor_ildpyw, /* 5x */            g65816_op_cli,     g65816_op_eor_addryw,           g65816_op_phyb,            g65816_op_tcd, /* 5x */       g65816_op_jmp_long,     g65816_op_eor_addrxw,     g65816_op_lsr_addrxw,     g65816_op_eor_longxw,
/* 6x */            g65816_op_rts,      g65816_op_adc_idpxw,            g65816_op_per,        g65816_op_adc_srw, /* 6x */        g65816_op_stz_dpw,        g65816_op_adc_dpw,        g65816_op_ror_dpw,      g65816_op_adc_ildpw, /* 6x */           g65816_op_plaw,     g65816_op_adc_constw,           g65816_op_rorw,            g65816_op_rtl, /* 6x */      g65816_op_jmp_iaddr,      g65816_op_adc_addrw,      g65816_op_ror_addrw,      g65816_op_adc_longw,
/* 7x */            g65816_op_bvs,      g65816_op_adc_idpyw,       g65816_op_adc_idpw,      g65816_op_adc_isryw, /* 7x */       g65816_op_stz_dpxw,       g65816_op_adc_dpxw,       g65816_op_ror_dpxw,     g65816_op_adc_ildpyw, /* 7x */            g65816_op_sei,     g65816_op_adc_addryw,           g65816_op_plyb,               g65816_tdc, /* 7x */     g65816_op_jmp_iaddrx,     g65816_op_adc_addrxw,     g65816_op_ror_addrxw,     g65816_op_adc_longxw,

/* 8x */            g65816_op_bra,      g65816_op_sta_idpxw,            g65816_op_brl,        g65816_op_sta_srw, /* 8x */        g65816_op_sty_dpb,        g65816_op_sta_dpw,        g65816_op_stx_dpb,      g65816_op_sta_ildpw, /* 8x */           g65816_op_deyb,     g65816_op_bit_constw,           g65816_op_txaw,            g65816_op_phb, /* 8x */      g65816_op_sty_addrb,      g65816_op_sta_addrw,      g65816_op_stx_addrb,      g65816_op_sta_longw,
/* 9x */            g65816_op_bcc,      g65816_op_sta_idpyw,       g65816_op_sta_idpw,      g65816_op_sta_isryw, /* 9x */       g65816_op_sty_dpxb,       g65816_op_sta_dpxw,       g65816_op_stx_dpyb,     g65816_op_sta_ildpyw, /* 9x */           g65816_op_tyaw,     g65816_op_sta_addryw,           g65816_op_txsb,           g65816_op_txyb, /* 9x */      g65816_op_stz_addrw,     g65816_op_sta_addrxw,     g65816_op_stz_addrxw,     g65816_op_sta_longxw,
/* ax */     g65816_op_ldy_constb,      g65816_op_lda_idpxw,     g65816_op_ldx_constb,        g65816_op_lda_srw, /* ax */        g65816_op_ldy_dpb,        g65816_op_lda_dpw,        g65816_op_ldx_dpb,      g65816_op_lda_ildpw, /* ax */           g65816_op_tayb,     g65816_op_lda_constw,           g65816_op_taxb,            g65816_op_plb, /* ax */      g65816_op_ldy_addrb,      g65816_op_lda_addrw,      g65816_op_ldx_addrb,      g65816_op_lda_longw,
/* bx */            g65816_op_bcs,      g65816_op_lda_idpyw,       g65816_op_lda_idpw,      g65816_op_lda_isryw, /* bx */       g65816_op_ldy_dpxb,       g65816_op_lda_dpxw,       g65816_op_ldx_dpyb,     g65816_op_lda_ildpyw, /* bx */            g65816_op_clv,     g65816_op_lda_addryw,           g65816_op_tsxb,           g65816_op_tyxb, /* bx */     g65816_op_ldy_addrxb,     g65816_op_lda_addrxw,     g65816_op_ldx_addryb,     g65816_op_lda_longxw,

/* cx */     g65816_op_cpy_constb,      g65816_op_cmp_idpxw,            g65816_op_rep,        g65816_op_cmp_srw, /* cx */        g65816_op_cpy_dpb,        g65816_op_cmp_dpw,        g65816_op_dec_dpw,      g65816_op_cmp_ildpw, /* cx */           g65816_op_inyb,     g65816_op_cmp_constw,           g65816_op_dexb,            g65816_op_wai, /* cx */      g65816_op_cpy_addrb,      g65816_op_cmp_addrw,      g65816_op_dec_addrw,      g65816_op_cmp_longw,
/* dx */            g65816_op_bne,      g65816_op_cmp_idpyw,       g65816_op_cmp_idpw,      g65816_op_cmp_isryw, /* dx */            g65816_op_pei,       g65816_op_cmp_dpxw,       g65816_op_dec_dpxw,     g65816_op_cmp_ildpyw, /* dx */            g65816_op_cld,     g65816_op_cmp_addryw,           g65816_op_phxb,            g65816_op_stp, /* dx */     g65816_op_jmp_iladdr,     g65816_op_cmp_addrxw,     g65816_op_dec_addrxw,     g65816_op_cmp_longxw,
/* ex */     g65816_op_cpx_constb,      g65816_op_sbc_idpxw,            g65816_op_sep,        g65816_op_sbc_srw, /* ex */        g65816_op_cpx_dpb,        g65816_op_sbc_dpw,        g65816_op_inc_dpw,      g65816_op_sbc_ildpw, /* ex */           g65816_op_inxb,     g65816_op_sbc_constw,            g65816_op_nop,            g65816_op_xba, /* ex */      g65816_op_cpx_addrb,      g65816_op_sbc_addrw,      g65816_op_inc_addrw,      g65816_op_sbc_longw,
/* fx */            g65816_op_beq,      g65816_op_sbc_idpyw,       g65816_op_sbc_idpw,      g65816_op_sbc_isryw, /* fx */            g65816_op_pea,       g65816_op_sbc_dpxw,       g65816_op_inc_dpxw,     g65816_op_sbc_ildpyw, /* fx */            g65816_op_sed,     g65816_op_sbc_addryw,           g65816_op_plxb,            g65816_op_xce, /* fx */     g65816_op_jsr_iaddrx,     g65816_op_sbc_addrxw,     g65816_op_inc_addrxw,     g65816_op_sbc_longxw
};

vfunc g65816_optbl_mx[256] = { //                                                                                g65816_optbl_mx,                                                                                                 g65816_optbl_mx,                                                                                                 g65816_optbl_mx,
      // ----------------------x0, ----------------------x1, ----------------------x2, ----------------------x3, -------- ----------------------x4, ----------------------x5, ----------------------x6, ----------------------x7, -------- ----------------------x8, ----------------------x9, ----------------------xa, ----------------------xb, -------- ----------------------xc, ----------------------xd, ----------------------xe, ----------------------xf,
/* 0x */            g65816_op_brk,      g65816_op_ora_idpxw,            g65816_op_cop,        g65816_op_ora_srw, /* 0x */        g65816_op_tsb_dpw,        g65816_op_ora_dpw,        g65816_op_asl_dpw,      g65816_op_ora_ildpw, /* 0x */            g65816_op_php,     g65816_op_ora_constw,           g65816_op_aslw,            g65816_op_phd, /* 0x */      g65816_op_tsb_addrw,      g65816_op_ora_addrw,      g65816_op_asl_addrw,      g65816_op_ora_longw,
/* 1x */            g65816_op_bpl,      g65816_op_ora_idpyw,       g65816_op_ora_idpw,      g65816_op_ora_isryw, /* 1x */        g65816_op_trb_dpw,       g65816_op_ora_dpxw,       g65816_op_asl_dpxw,     g65816_op_ora_ildpyw, /* 1x */            g65816_op_clc,     g65816_op_ora_addryw,           g65816_op_incw,           g65816_op_tcsn, /* 1x */      g65816_op_trb_addrw,     g65816_op_ora_addrxw,     g65816_op_asl_addrxw,     g65816_op_ora_longxw,
/* 2x */       g65816_op_jsr_addr,      g65816_op_and_idpxw,       g65816_op_jsr_long,        g65816_op_and_srw, /* 2x */        g65816_op_bit_dpw,        g65816_op_and_dpw,        g65816_op_rol_dpw,      g65816_op_and_ildpw, /* 2x */            g65816_op_plp,     g65816_op_and_constw,           g65816_op_rolw,            g65816_op_pld, /* 2x */      g65816_op_bit_addrw,      g65816_op_and_addrw,      g65816_op_rol_addrw,      g65816_op_and_longw,
/* 3x */            g65816_op_bmi,      g65816_op_and_idpyw,       g65816_op_and_idpw,      g65816_op_and_isryw, /* 3x */       g65816_op_bit_dpxw,       g65816_op_and_dpxw,       g65816_op_rol_dpxw,     g65816_op_and_ildpyw, /* 3x */            g65816_op_sec,     g65816_op_and_addryw,           g65816_op_decw,           g65816_op_tscn, /* 3x */     g65816_op_bit_addrxw,     g65816_op_and_addrxw,     g65816_op_rol_addrxw,     g65816_op_and_longxw,

/* 4x */           g65816_op_rtin,      g65816_op_eor_idpxw,            g65816_op_wdm,        g65816_op_eor_srw, /* 4x */            g65816_op_mvp,        g65816_op_eor_dpw,        g65816_op_lsr_dpw,      g65816_op_eor_ildpw, /* 4x */           g65816_op_phaw,     g65816_op_eor_constw,           g65816_op_lsrw,            g65816_op_phk, /* 4x */       g65816_op_jmp_addr,      g65816_op_eor_addrw,      g65816_op_lsr_addrw,      g65816_op_eor_longw,
/* 5x */            g65816_op_bvc,      g65816_op_eor_idpyw,       g65816_op_eor_idpw,      g65816_op_eor_isryw, /* 5x */            g65816_op_mvn,       g65816_op_eor_dpxw,       g65816_op_lsr_dpxw,     g65816_op_eor_ildpyw, /* 5x */            g65816_op_cli,     g65816_op_eor_addryw,           g65816_op_phyw,            g65816_op_tcd, /* 5x */       g65816_op_jmp_long,     g65816_op_eor_addrxw,     g65816_op_lsr_addrxw,     g65816_op_eor_longxw,
/* 6x */            g65816_op_rts,      g65816_op_adc_idpxw,            g65816_op_per,        g65816_op_adc_srw, /* 6x */        g65816_op_stz_dpw,        g65816_op_adc_dpw,        g65816_op_ror_dpw,      g65816_op_adc_ildpw, /* 6x */           g65816_op_plaw,     g65816_op_adc_constw,           g65816_op_rorw,            g65816_op_rtl, /* 6x */      g65816_op_jmp_iaddr,      g65816_op_adc_addrw,      g65816_op_ror_addrw,      g65816_op_adc_longw,
/* 7x */            g65816_op_bvs,      g65816_op_adc_idpyw,       g65816_op_adc_idpw,      g65816_op_adc_isryw, /* 7x */       g65816_op_stz_dpxw,       g65816_op_adc_dpxw,       g65816_op_ror_dpxw,     g65816_op_adc_ildpyw, /* 7x */            g65816_op_sei,     g65816_op_adc_addryw,           g65816_op_plyw,               g65816_tdc, /* 7x */     g65816_op_jmp_iaddrx,     g65816_op_adc_addrxw,     g65816_op_ror_addrxw,     g65816_op_adc_longxw,

/* 8x */            g65816_op_bra,      g65816_op_sta_idpxw,            g65816_op_brl,        g65816_op_sta_srw, /* 8x */        g65816_op_sty_dpw,        g65816_op_sta_dpw,        g65816_op_stx_dpw,      g65816_op_sta_ildpw, /* 8x */           g65816_op_deyw,     g65816_op_bit_constw,           g65816_op_txaw,            g65816_op_phb, /* 8x */      g65816_op_sty_addrw,      g65816_op_sta_addrw,      g65816_op_stx_addrw,      g65816_op_sta_longw,
/* 9x */            g65816_op_bcc,      g65816_op_sta_idpyw,       g65816_op_sta_idpw,      g65816_op_sta_isryw, /* 9x */       g65816_op_sty_dpxw,       g65816_op_sta_dpxw,       g65816_op_stx_dpyw,     g65816_op_sta_ildpyw, /* 9x */           g65816_op_tyaw,     g65816_op_sta_addryw,           g65816_op_txsw,           g65816_op_txyw, /* 9x */      g65816_op_stz_addrw,     g65816_op_sta_addrxw,     g65816_op_stz_addrxw,     g65816_op_sta_longxw,
/* ax */     g65816_op_ldy_constw,      g65816_op_lda_idpxw,     g65816_op_ldx_constw,        g65816_op_lda_srw, /* ax */        g65816_op_ldy_dpw,        g65816_op_lda_dpw,        g65816_op_ldx_dpw,      g65816_op_lda_ildpw, /* ax */           g65816_op_tayw,     g65816_op_lda_constw,           g65816_op_taxw,            g65816_op_plb, /* ax */      g65816_op_ldy_addrw,      g65816_op_lda_addrw,      g65816_op_ldx_addrw,      g65816_op_lda_longw,
/* bx */            g65816_op_bcs,      g65816_op_lda_idpyw,       g65816_op_lda_idpw,      g65816_op_lda_isryw, /* bx */       g65816_op_ldy_dpxw,       g65816_op_lda_dpxw,       g65816_op_ldx_dpyw,     g65816_op_lda_ildpyw, /* bx */            g65816_op_clv,     g65816_op_lda_addryw,           g65816_op_tsxw,           g65816_op_tyxw, /* bx */     g65816_op_ldy_addrxw,     g65816_op_lda_addrxw,     g65816_op_ldx_addryw,     g65816_op_lda_longxw,

/* cx */     g65816_op_cpy_constw,      g65816_op_cmp_idpxw,            g65816_op_rep,        g65816_op_cmp_srw, /* cx */        g65816_op_cpy_dpw,        g65816_op_cmp_dpw,        g65816_op_dec_dpw,      g65816_op_cmp_ildpw, /* cx */           g65816_op_inyw,     g65816_op_cmp_constw,           g65816_op_dexw,            g65816_op_wai, /* cx */      g65816_op_cpy_addrw,      g65816_op_cmp_addrw,      g65816_op_dec_addrw,      g65816_op_cmp_longw,
/* dx */            g65816_op_bne,      g65816_op_cmp_idpyw,       g65816_op_cmp_idpw,      g65816_op_cmp_isryw, /* dx */            g65816_op_pei,       g65816_op_cmp_dpxw,       g65816_op_dec_dpxw,     g65816_op_cmp_ildpyw, /* dx */            g65816_op_cld,     g65816_op_cmp_addryw,           g65816_op_phxw,            g65816_op_stp, /* dx */     g65816_op_jmp_iladdr,     g65816_op_cmp_addrxw,     g65816_op_dec_addrxw,     g65816_op_cmp_longxw,
/* ex */     g65816_op_cpx_constw,      g65816_op_sbc_idpxw,            g65816_op_sep,        g65816_op_sbc_srw, /* ex */        g65816_op_cpx_dpw,        g65816_op_sbc_dpw,        g65816_op_inc_dpw,      g65816_op_sbc_ildpw, /* ex */           g65816_op_inxw,     g65816_op_sbc_constw,            g65816_op_nop,            g65816_op_xba, /* ex */      g65816_op_cpx_addrw,      g65816_op_sbc_addrw,      g65816_op_inc_addrw,      g65816_op_sbc_longw,
/* fx */            g65816_op_beq,      g65816_op_sbc_idpyw,       g65816_op_sbc_idpw,      g65816_op_sbc_isryw, /* fx */            g65816_op_pea,       g65816_op_sbc_dpxw,       g65816_op_inc_dpxw,     g65816_op_sbc_ildpyw, /* fx */            g65816_op_sed,     g65816_op_sbc_addryw,           g65816_op_plxw,            g65816_op_xce, /* fx */     g65816_op_jsr_iaddrx,     g65816_op_sbc_addrxw,     g65816_op_inc_addrxw,     g65816_op_sbc_longxw
};
